<template>
  <q-page>
    <div class="row justify-center q-my-md">
      <div class="col-6">
        <q-card class="my-card">
          <q-card-section class="text-right">
            <p class="darkText text-caption">Todos os campos são obrigatórios *</p>
            <q-separator inset />
          </q-card-section>
          <q-card-section>
            <q-input
              filled
              label="Código da transação *"
              v-model="form.codigoTransacao"
              required
              @input="$v.form.codigoTransacao.$touch()"
              :error="$v.form.codigoTransacao.$error"
            />
          </q-card-section>
          <q-card-section>
            <q-input
              filled
              label="Descrição *"
              v-model="form.descricaoTransacao"
              @input="$v.form.descricaoTransacao.$touch()"
              :error="$v.form.descricaoTransacao.$error"
            />
          </q-card-section>
          <q-card-section>
            <q-input
              filled
              label="Endpoint *"
              v-model="form.endPoint"
              @input="$v.form.endPoint.$touch()"
              :error="$v.form.endPoint.$error"
            />
          </q-card-section>
          <q-card-section>
            <q-toggle :label="form.status ? 'Atviado': 'Desativado'" type="toggle" v-model="form.status" />
          </q-card-section>
          <q-card-section>
            <q-input
              filled
              label="Tópico *"
              v-model="form.topicoFila"
              @input="$v.form.topicoFila.$touch()"
              :error="$v.form.topicoFila.$error"
            />
          </q-card-section>
          <q-card-section>
            <q-input
              filled
              label="Endereço *"
              v-model="form.enderecoFila"
              @input="$v.form.enderecoFila.$touch()"
              :error="$v.form.enderecoFila.$error"
            />
          </q-card-section>
          <q-card-actions class="row justify-end">
            <q-btn flat @click="back()">Voltar</q-btn>
            <q-btn
              color="primary"
              @click="saveTransaction(form)"
              :disable="isDisabled()"
              :outline="isDisabled()"
            >Salvar</q-btn>
          </q-card-actions>
        </q-card>
      </div>
    </div>
  </q-page>
</template>

<script>
import { minLength, maxLength, required } from 'vuelidate/lib/validators'
import formErrors from '@mixins/form-errors.mixin'
import Transaction from '@services/transaction/Transaction'
import Notify from '@mixins/notify.mixin'
export default {
  mixins: [Notify, formErrors],
  data () {
    return {
      Transaction: new Transaction(),
      form: {
        codigoTransacao: '',
        descricaoTransacao: '',
        endPoint: '',
        status: true,
        topicoFila: '',
        enderecoFila: ''
      },
      formId: parseInt(this.$route.params.id)
    }
  },
  mounted () {
    if (this.formId) this.getTransaction(this.formId)
  },
  methods: {
    back () {
      this.$router.go(-1)
    },
    getTransaction (formId) {
      this.$q.loading.show()
      this.Transaction.get(formId)
        .then(result => {
          this.form = result.data
        })
        .catch(err => {
          this.NotifyDanger(err.message)
        })
        .finally(() => this.$q.loading.hide())
    },
    saveTransaction (form) {
      this.$q.loading.show()
      let fields = [this.$v.form]
      this.verifyErrorsForm(fields)
        .then(() => {
          this.Transaction.create(form)
            .then(result => {
              this.NotifySuccess('Transação cadastrada com sucesso')
            })
            .catch(err => {
              this.NotifyDanger(err.message)
            })
            .finally(() => this.$q.loading.hide())
        })
        .catch(err => this.NotifyDanger(err.message))
    },
    isDisabled () {
      return this.$v.form.$invalid || this.$v.form.$error
    }
  },
  validations: {
    form: {
      codigoTransacao: {
        required,
        minLength: minLength(1),
        maxLength: maxLength(10)
      },
      descricaoTransacao: {
        minLength: minLength(1),
        maxLength: maxLength(100)
      },
      endPoint: {
        minLength: minLength(1),
        maxLength: maxLength(50)
      },
      topicoFila: {
        minLength: minLength(1),
        maxLength: maxLength(50)
      },
      enderecoFila: {
        minLength: minLength(1),
        maxLength: maxLength(50)
      }
    }
  }
}
</script>

<style>
.darkText {
  color: #272727;
}
</style>
